unit unit_Doc2RTF;
{ BlueGYN 2009
  Conversion des fichier WORD DOC en RTF
  Word doit tre install
  Processus AUTOMATION appel via comOBJ (Delphi lance des Macros de Word)
}

interface

uses  SysUtils, {StringReplace }
      StrUtils, {ReverseString }
      comOBJ, SHDocVw, Registry, ShlObj,

      variables_globales,

      jc_DIR,
      Windows;

Function Doc2RTF ( DOC : String) : String ;
Function Doc2TXT ( DOC : String) : String ;

implementation

uses Unit1; { Dropper_filename }


//////////////////////////////////////////////////////
Function Doc2RTF ( DOC : String) : String ;
//////////////////////////////////////////////////////
{
  BlueGYN 2009
  - Retourne le contenu du document (string)
}

var
  WordApplication, WordDocument, WordDocuments : variant;
	RTF, myDir, Text : string;
  i: integer;
const wdSeekCurrentPageHeader = 9;
const wdSeekMainDocument = 0;
const wdPasteDefault = 0;
const wdFormatRTF = 6;
const wdReplaceAll = 2;
const wdFindContinue = 1;
const wdAlignParagraphLeft = 0;
const wdPaneNone = 0;
const wdNormalView = 1;
const wdOutlineView = 2;
const wdPrintView = 3 ;
const wdLine = 5;
const wdStory = 6;
const wdWithInTable = 12;

Begin
// --- OUVRE WORD ---
// tente une connexion => Si chec => Ouvre Word

try

  form1.Cursor := 0;

 	WordApplication := GetActiveOleObject('Word.Application');
	except
	WordApplication := CreateOleObject('Word.Application');
	end;

  WordApplication.Visible := False ; // WORD reste cach

  // === Ouvre le doc FN ===
  WordDocuments := WordApplication.Documents;
  WordDocument  := WordDocuments.Open( DOC ); // FN est pass en argument

  If WordDocument.ActiveWindow.View.SplitSpecial <> wdPaneNone
    Then WordDocument.ActiveWindow.Panes(2).Close;
  If (WordDocument.ActiveWindow.ActivePane.View.Type = wdNormalView)
    Or (WordDocument.ActiveWindow.ActivePane.View.Type = wdOutlineView)
      Then WordDocument.ActiveWindow.ActivePane.View.Type := wdPrintView;

  // --- OUVRE L'ENTETE ---
  WordDocument.ActiveWindow.ActivePane.View.SeekView := wdSeekCurrentPageHeader;

  // --- MET LE TEXTE DE L'ENTETE EN MEMOIRE ---
  WordApplication.Selection.WholeStory ; // CTRL + A
  // --- Aligne a gauche
  WordApplication.Selection.ParagraphFormat.Alignment := wdAlignParagraphLeft;

  for i := 1 to 3 do begin
  // --- remplace les double saut par des simples ------------------------------
      WordApplication.Selection.Find.ClearFormatting;
      WordApplication.Selection.Find.Replacement.ClearFormatting;
      WordApplication.Selection.Find.Text := '^p^p';
      WordApplication.Selection.Find.Replacement.Text := '^p';
      WordApplication.Selection.Find.Forward := True;
      WordApplication.Selection.Find.Wrap := wdFindContinue;
      WordApplication.Selection.Find.Format := False;
      WordApplication.Selection.Find.MatchCase := False;
      WordApplication.Selection.Find.MatchWholeWord := False;
      WordApplication.Selection.Find.MatchWildcards := False;
      WordApplication.Selection.Find.MatchSoundsLike := False;
      WordApplication.Selection.Find.MatchAllWordForms := False;
      WordApplication.Selection.Find.Execute ( Replace := wdReplaceAll );
  // ---------------------------------------------------------------------------
  End;

  // Coupe le texte en mmoire PP
  WordApplication.Selection.Cut   ;     // CTRL + C

  If WordDocument.ActiveWindow.View.SplitSpecial <> wdPaneNone
    Then WordDocument.ActiveWindow.Panes(2).Close;
  If (WordDocument.ActiveWindow.ActivePane.View.Type = wdNormalView)
    Or (WordDocument.ActiveWindow.ActivePane.View.Type = wdOutlineView)
      Then WordDocument.ActiveWindow.ActivePane.View.Type := wdPrintView;

  // OUVRE MAINTENANT LE CORPS DU DOC ---
  //WordDocument.ActiveWindow.ActivePane.View.SeekView := wdSeekCurrentPageHeader;
  WordDocument.ActiveWindow.ActivePane.View.SeekView := wdSeekMainDocument;

  // Insre un paragraphe vide au-dessus de la premire ligne de la slection. Si la slection ne se

  WordApplication.Selection.HomeKey (Unit:=wdLine);
  WordApplication.Selection.HomeKey (Unit:=wdStory);
     // Isole le dbut du texte
  WordApplication.Selection.TypeText(Text:=' ');
  WordApplication.Selection.TypeParagraph;

   //If (WordApplication.Selection.Information(wdWithInTable) = True)
   //  Then WordApplication.Selection.SplitTable
   //  else
   // WordApplication.Selection.TypeParagraph;


  // COLLE L'ENTETE AU POINT D'INSERTION
  WordApplication.Selection.PasteAndFormat( wdPasteDefault ) ;


 	// --- rcupre le text en totalit
  text := WordDocument.content.text;
  // Remplace les retours chariot CR par des CR + LF
  text := StringReplace(text, chr(13), chr(13)+chr(10) , [rfReplaceAll,rfIgnoreCase]);
  // Retourne le Texte
  result := text;

  // === Sauve le tout au format RTF
  // Extrait le nom du fichier du chemin
  myDir := ExtractFileDir( DOC );
  RTF := ExtractFileName( DOC );

  // Remplace le DOC par un RTF
  RTF := ChangeFileExt ( RTF , '.RTF');

  // Reconstruit le nom du chemin => Cible
  RTF := myDir + '\' + RTF;
   // Conversion Str vers Array
  for i := 0 to length( RTF ) do _DROPPED_FILENAME[i] := RTF [I+1];



  /// Showmessage(fn);

  // Lance la sauvegarde du RTF
   WordApplication.ChangeFileOpenDirectory( myDir );
   WordDocument.SaveAs (FileName := RTF ,
   		FileFormat:= wdFormatRTF,
         LockComments:=False,
         Password:='',
         AddToRecentFiles:=True,
        WritePassword:='',
        ReadOnlyRecommended:=False,
        EmbedTrueTypeFonts:=False,
         SaveNativePictureFormat:=False,
         SaveFormsData:=False,
         SaveAsAOCELetter:= False);

    WordDocument.Close;

    // ActiveDocument.Close
   WordApplication.Quit;

   // Supprime le DOC
   DeleteFileToRecycleBin ( DOC );

End;

//////////////////////////////////////////////////////
Function Doc2TXT ( DOC : String) : String ;
//////////////////////////////////////////////////////
var
  WordApplication, WordDocument, WordDocuments : variant;
	TXT, myDir, Text : string;
  i: integer;

const wdFormatText = 2;
const wdCRLF = 0;


Begin
// --- OUVRE WORD ---
// tente une connexion => Si chec => Ouvre Word

try

  form1.Cursor := 0;

 	WordApplication := GetActiveOleObject('Word.Application');
	except
	WordApplication := CreateOleObject('Word.Application');
	end;

  WordApplication.Visible := False ; // WORD reste cach

  // === Ouvre le doc FN ===
  WordDocuments := WordApplication.Documents;
  WordDocument  := WordDocuments.Open( DOC ); // FN est pass en argument

 	// --- rcupre le text en totalit
  text := WordDocument.content.text;
  // Remplace les retours chariot CR par des CR + LF
  text := StringReplace(text, chr(13), chr(13)+chr(10) , [rfReplaceAll,rfIgnoreCase]);
  // Retourne le Texte
  result := text;

  // === Sauve le tout au format TXT
  // Extrait le nom du fichier du chemin
  myDir := ExtractFileDir( DOC );
  TXT := ExtractFileName( DOC );

  // Remplace le DOC par un TXT
  TXT := ChangeFileExt ( TXT , '.TXT');

  // Reconstruit le nom du chemin => Cible
  TXT := myDir + '\' + TXT;
   // Conversion Str vers Array
  for i := 0 to length( TXT ) do _DROPPED_FILENAME[i] := TXT [I+1];



  /// Showmessage(fn);

  // Lance la sauvegarde du TXT
   WordApplication.ChangeFileOpenDirectory( myDir );

   WordDocument.SaveAs (FileName:=TXT,
   	FileFormat:=wdFormatText,
    LockComments:=False,
    Password:='',
    AddToRecentFiles:=True,
    WritePassword:='',
    ReadOnlyRecommended:=False,
    EmbedTrueTypeFonts:=False,
    SaveNativePictureFormat:=False,
    SaveFormsData:=False,
    SaveAsAOCELetter:=False,
    Encoding:=1252,
    InsertLineBreaks:=False,
    AllowSubstitutions:=False,
    LineEnding:=wdCRLF);

    WordDocument.Close;

    // ActiveDocument.Close
   WordApplication.Quit;

   // Supprime le DOC
   DeleteFileToRecycleBin ( DOC );

End;


end.
